This patch contains all new IBM features for s390-tools-1.8.0 SLES11 SP1.
It applies to Novell s390-tools-1.8.0-43.3.2 plus the following add-on
patch: s390-tools-sles11sp1-dasdfmt-norecord_r0.patch

Summary:     iucvterm: IUCV terminal applications
Description: The IUCV terminal application consists of iucvconn, iucvtty,
             and ts-shell. In addition, this feature patch provides the
             documentation for these tools.
             The iucvconn program establishes a terminal connection to
             another Linux instance. The communication path between both
             virtual machines is based on z/VM IUCV. Because IUCV is
             independent from TCP/IP, Linux instances with no external
             network can be accessed.
             iucvconn can establish connections to either an iucvtty
             instance or a z/VM IUCV HVC terminal device.
             The iucvtty program allows remote logins over IUCV.
             ts-shell is a login shell for terminal servers using
             iucvconn to access the terminals over z/VM IUCV.

Summary:     zipl, dasdview, dasdfmt, fdasd: Add large volume support
Description: Add support for the new disk sizes and the extended
             label information (cdl and ldl).

Summary:     zipl dump tools: Add large volume support
Description: DASD dump tools are enabled to support devices with more
             than 65520 cylinders.

Summary:     dasdview: DS8000 disk encryption support
Description: Add support for encrypted disks on DS8000
             Add option -c or --characteristic to dasdview to.
             show if a disk is encrypted or not..

Summary:     lsluns: Add disk encryption display feature.
Description: Add support for displaying the new disk encryption feature.

Summary:     Add ziomon reporting tools
Description: Tool set for zfcp performance report creation.

Summary:     dumpconf: New shutdown action "dump_reipl" for dumpconf.
Description: The dump tools are enabled to trigger re-IPL after the dump
             process has completed.

Summary:     vmur: Add --convert option
Description: Convert VMDUMP spool file into a format appropriate for further
             analysis with crash or lcrash, while receiving it.

Summary:     zconf: Add new network configuration tool znetconf
Description: znetconf lists and configures network devices for System z
             network adapters.
---
 Makefile                                        |    2 
 README                                          |   19 
 common.mak                                      |   12 
 dasdfmt/dasdfmt.c                               |  134 +
 dasdfmt/dasdfmt.h                               |  107 -
 dasdview/dasdview.8                             |   18 
 dasdview/dasdview.c                             |  681 ++++---
 dasdview/dasdview.h                             |   29 
 etc/init.d/dumpconf                             |  172 +
 etc/sysconfig/dumpconf                          |   19 
 fdasd/fdasd.c                                   |  481 +++--
 fdasd/fdasd.h                                   |   26 
 include/vtoc.h                                  |  112 -
 iucvterm/Makefile                               |   28 
 iucvterm/bin/Makefile                           |   42 
 iucvterm/bin/chiucvallow.in                     |  273 +++
 iucvterm/bin/ts-shell.in                        |  669 +++++++
 iucvterm/doc/Makefile                           |   27 
 iucvterm/doc/chiucvallow.8                      |  145 +
 iucvterm/doc/hvc_iucv.9                         |  340 +++
 iucvterm/doc/iucvconn.1                         |  223 ++
 iucvterm/doc/iucvtty.1                          |  205 ++
 iucvterm/doc/ts-shell.1                         |  574 ++++++
 iucvterm/doc/ts-shell/README.ts-shell           |  126 +
 iucvterm/doc/ts-shell/authorization-sample.conf |   24 
 iucvterm/doc/ts-shell/iucvconn_on_login         |   35 
 iucvterm/doc/ts-shell/sample-system.list        |   11 
 iucvterm/etc/Makefile                           |   30 
 iucvterm/etc/ts-audit-systems.conf              |    3 
 iucvterm/etc/ts-authorization.conf              |    6 
 iucvterm/etc/ts-shell.conf.in                   |   27 
 iucvterm/etc/unrestricted.conf                  |    2 
 iucvterm/include/af_iucv.h                      |   29 
 iucvterm/include/iucvterm/config.h              |   31 
 iucvterm/include/iucvterm/functions.h           |   74 
 iucvterm/include/iucvterm/gettext.h             |   74 
 iucvterm/include/iucvterm/proto.h               |  108 +
 iucvterm/po/Makefile                            |   57 
 iucvterm/po/POTFILES.in                         |    4 
 iucvterm/src/Makefile                           |   33 
 iucvterm/src/auditlog.c                         |  207 ++
 iucvterm/src/functions.c                        |  519 +++++
 iucvterm/src/getopt.c                           |  226 ++
 iucvterm/src/iucvconn.c                         |  349 ++++
 iucvterm/src/iucvtty.c                          |  292 +++
 iucvterm/test/Makefile                          |   40 
 iucvterm/test/test.h                            |   24 
 iucvterm/test/test_afiucv.c                     |   30 
 iucvterm/test/test_allow.c                      |   77 
 iucvterm/test/test_auditlog.c                   |   76 
 iucvterm/test/test_common.c                     |   40 
 iucvterm/test/test_functions.c                  |  243 ++
 libvtoc/vtoc.c                                  |  215 +-
 man/Makefile                                    |   19 
 man/af_iucv.7                                   |  402 ++++
 man/dumpconf.8                                  |   56 
 vmconvert/Makefile                              |    5 
 vmconvert/convert.cpp                           |   71 
 vmconvert/dump.cpp                              |   26 
 vmconvert/dump.h                                |   17 
 vmconvert/lkcd_dump.cpp                         |   47 
 vmconvert/main.cpp                              |   69 
 vmconvert/register_content.cpp                  |    4 
 vmconvert/vm_dump.cpp                           |  139 -
 vmur/Makefile                                   |   19 
 vmur/vmur.8                                     |    8 
 vmur/vmur.c                                     | 2054 -----------------------
 vmur/vmur.cpp                                   | 2092 ++++++++++++++++++++++++
 vmur/vmur.h                                     |   14 
 zconf/Makefile                                  |    7 
 zconf/lsluns                                    |  137 +
 zconf/lsluns.8                                  |   12 
 zconf/lsznet.raw                                |  363 ++++
 zconf/znetconf                                  | 1418 ++++++++++++++++
 zconf/znetconf.8                                |  313 +++
 zconf/znetcontrolunits                          |   53 
 zfcpdump_v2/zfcpdump.c                          |    8 
 zfcpdump_v2/zfcpdump.h                          |    2 
 ziomon/Makefile                                 |   39 
 ziomon/blkiomon.h                               |   45 
 ziomon/stats.h                                  |   41 
 ziomon/ziomon                                   |  124 +
 ziomon/ziomon.8                                 |   12 
 ziomon/ziomon_dacc.c                            |  528 ++++--
 ziomon/ziomon_dacc.h                            |  108 +
 ziomon/ziomon_fcpconf                           |   12 
 ziomon/ziomon_fcpconf.8                         |   13 
 ziomon/ziomon_mgr.8                             |   13 
 ziomon/ziomon_mgr.c                             |  329 +--
 ziomon/ziomon_msg_tools.c                       |  137 +
 ziomon/ziomon_msg_tools.h                       |   29 
 ziomon/ziomon_tools.c                           |   56 
 ziomon/ziomon_tools.h                           |   34 
 ziomon/ziomon_util.8                            |   12 
 ziomon/ziomon_util.c                            |  564 +++---
 ziomon/ziomon_util.h                            |   69 
 ziomon/ziomon_zfcpdd.8                          |   18 
 ziomon/ziomon_zfcpdd.c                          |  180 +-
 ziomon/ziomon_zfcpdd.h                          |   22 
 ziomon/ziorep_cfgreader.cpp                     |  889 ++++++++++
 ziomon/ziorep_cfgreader.hpp                     |  239 ++
 ziomon/ziorep_collapser.cpp                     |  570 ++++++
 ziomon/ziorep_collapser.hpp                     |  185 ++
 ziomon/ziorep_config                            |  492 +++++
 ziomon/ziorep_config.8                          |  118 +
 ziomon/ziorep_filters.cpp                       |  516 +++++
 ziomon/ziorep_filters.hpp                       |  214 ++
 ziomon/ziorep_framer.cpp                        |  288 +++
 ziomon/ziorep_framer.hpp                        |   79 
 ziomon/ziorep_frameset.cpp                      |  607 ++++++
 ziomon/ziorep_frameset.hpp                      |  228 ++
 ziomon/ziorep_printers.cpp                      | 1254 ++++++++++++++
 ziomon/ziorep_printers.hpp                      |  220 ++
 ziomon/ziorep_traffic.8                         |  216 ++
 ziomon/ziorep_traffic.cpp                       |  547 ++++++
 ziomon/ziorep_utilization.8                     |  137 +
 ziomon/ziorep_utilization.cpp                   |  372 ++++
 ziomon/ziorep_utils.cpp                         |  555 ++++++
 ziomon/ziorep_utils.hpp                         |   85 
 zipl/boot/Makefile                              |   31 
 zipl/boot/dumpcommon.S                          |   86 
 zipl/boot/eckd2dump.S                           |  241 --
 zipl/boot/eckd2mvdump.S                         |   42 
 zipl/boot/tapedump.S                            |   95 -
 zipl/include/disk.h                             |    1 
 zipl/man/zipl.conf.5                            |    3 
 zipl/src/Makefile                               |    7 
 zipl/src/boot.c                                 |  107 -
 zipl/src/bootmap.c                              |    3 
 zipl/src/disk.c                                 |   24 
 zipl/src/install.c                              |   98 -
 zipl/src/job.c                                  |    6 
 zipl/src/zipl.c                                 |    4 
 133 files changed, 21389 insertions(+), 4260 deletions(-)

Index: s390-tools-sles11/Makefile
===================================================================
--- s390-tools-sles11.orig/Makefile
+++ s390-tools-sles11/Makefile
@@ -3,7 +3,7 @@ ARCH := $(shell uname -m | sed -e s/i.86
 # Include commond definitions
 include common.mak
 
-SUB_DIRS  = libvtoc zipl zdump fdasd dasdfmt dasdview tunedasd tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools ziomon
+SUB_DIRS  = libvtoc zipl zdump fdasd dasdfmt dasdview tunedasd tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools ziomon iucvterm
 
 ifeq ($(strip $(SYSFS)),true)
 	SUB_DIRS+=libu2s
Index: s390-tools-sles11/README
===================================================================
--- s390-tools-sles11.orig/README
+++ s390-tools-sles11/README
@@ -108,6 +108,8 @@ s390-tools (1.8.0)
      - lsluns:   List available SCSI LUNs depending on adapter or port.
      - lszcrypt: Show Information about zcrypt devices and configuration.
      - chzcrypt: Modify zcrypt configuration.
+     - znetconf: List and configure network devices for System z network
+                 adapters.
 
    * dumpconf:
      Allows to configure the dump device used for system dump in case a kernel
@@ -139,11 +141,26 @@ s390-tools (1.8.0)
                 reboot or panic.
 
    * ziomon tools:
-     Tool set to collect data for zfcp performance analysis.
+     Tool set to collect data for zfcp performance analysis and generate
+     reports.
+
+   * iucvterm:
+     z/VM IUCV terminal applications.
+
+     A set of applications to provide terminal access over the z/VM Inter-User
+     Communication Vehicle (IUCV). The terminal access does not require an
+     active IP network connection between two Linux guest operating systems.
+
+     - iucvconn:  Start terminal connection over z/VM IUCV.
+     - iucvtty:   Allow remote logins over z/VM IUCV.
+     - ts-shell:  Terminal server shell to authorize and control IUCV terminal
+                  connections for individual Linux users.
+
 
 For more information refer to the following publications:
    * "Device Drivers, Features, and Commands" chapter "Useful Linux commands"
    * "Using the dump tools"
+   * "How to Set up a Terminal Server Environment"
 
 Dependencies:
 =============
Index: s390-tools-sles11/common.mak
===================================================================
--- s390-tools-sles11.orig/common.mak
+++ s390-tools-sles11/common.mak
@@ -2,10 +2,13 @@ ifndef $(COMMON_INCLUDED)
 COMMON_INCLUDED = true
 
 # Global definitions
+# The variable "DISTRELEASE" should be overwritten in rpm spec files with:
+# "make DISTRELEASE=%{release}" and "make install DISTRELEASE=%{release}"
 VERSION            = 1
 RELEASE            = 8
 PATCHLEVEL         = 0
-S390_TOOLS_RELEASE = $(VERSION).$(RELEASE).$(PATCHLEVEL)
+DISTRELEASE        = build-$(shell date +%Y%m%d)
+S390_TOOLS_RELEASE = $(VERSION).$(RELEASE).$(PATCHLEVEL)-$(DISTRELEASE)
 SYSFS              = true
 export S390_TOOLS_RELEASE SYSFS 
 
@@ -22,7 +25,8 @@ STRIP           = $(CROSS_COMPILE)strip
 OBJCOPY         = $(CROSS_COMPILE)objcopy
 OBJDUMP         = $(CROSS_COMPILE)objdump
 INSTALL         = install # FIXME: We need s390-install (strip)
-CFLAGS		= $(OPT_FLAGS) -Wall -O3 -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE)
+CFLAGS          = $(OPT_FLAGS) -Wall -O3 -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE)
+CXXFLAGS        = $(OPT_FLAGS) -Wall -O3 -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE)
 export AS LD CC CPP AR NM STRIP OBJCOPY OBJDUMP INSTALL CFLAGS
 
 # Support alternate install root
@@ -31,8 +35,10 @@ USRSBINDIR      = $(INSTROOT)/usr/sbin
 USRBINDIR       = $(INSTROOT)/usr/bin
 BINDIR          = $(INSTROOT)/sbin
 LIBDIR          = $(INSTROOT)/lib
+SYSCONFDIR      = $(INSTROOT)/etc
 MANDIR          = $(INSTROOT)/usr/share/man
-INSTDIRS        = $(USRSBINDIR) $(USRBINDIR) $(BINDIR) $(LIBDIR) $(MANDIR)
+TOOLS_LIBDIR    = $(INSTROOT)/lib/s390-tools
+INSTDIRS        = $(USRSBINDIR) $(USRBINDIR) $(BINDIR) $(LIBDIR) $(MANDIR) $(TOOLS_LIBDIR)
 OWNER           = $(shell id -un)
 GROUP		= $(shell id -gn)
 export INSTROOT BINDIR LIBDIR MANDIR OWNER GROUP
Index: s390-tools-sles11/dasdfmt/dasdfmt.c
===================================================================
--- s390-tools-sles11.orig/dasdfmt/dasdfmt.c
+++ s390-tools-sles11/dasdfmt/dasdfmt.c
@@ -23,6 +23,12 @@ static const char tool_name[] = "dasdfmt
 /* Copyright notice */
 static const char copyright_notice[] = "Copyright IBM Corp. 1999, 2006";
 
+static int            filedes        = 0;
+static int            disk_disabled  = 0;
+static format_data_t  format_params;
+char                 *prog_name;
+volatile sig_atomic_t program_interrupt_in_progress = 0;
+
 /*
  * Print version information.
  */
@@ -380,13 +386,13 @@ static format_data_t ask_user_for_blksiz
  * print all information needed to format the device
  */
 static void dasdfmt_print_info(dasdfmt_info_t *info, volume_label_t *vlabel,
-			       struct hd_geometry *drive_geo, format_data_t *p)
+			       unsigned int cylinders, unsigned int heads,
+			       format_data_t *p)
 {
 	char volser[6], vollbl[4];
 
 	printf("Drive Geometry: %d Cylinders * %d Heads =  %d Tracks\n",
-	       drive_geo->cylinders, drive_geo->heads,
-	       (drive_geo->cylinders * drive_geo->heads));
+	       cylinders, heads, (cylinders * heads));
 
 	printf("\nI am going to format the device ");
 	printf("%s in the following way:\n", info->devname);
@@ -453,7 +459,8 @@ static int dasdfmt_get_volser(char * dev
 /*
  * do all the labeling (volume label and initial VTOC)
  */
-static void dasdfmt_write_labels(dasdfmt_info_t *info, volume_label_t *vlabel)
+static void dasdfmt_write_labels(dasdfmt_info_t *info, volume_label_t *vlabel,
+				 unsigned int cylinders, unsigned int heads)
 {
 	unsigned int        label_position;
 	dasd_information_t  dasd_info;
@@ -472,7 +479,12 @@ static void dasdfmt_write_labels(dasdfmt
 	if (ioctl(filedes, BLKSSZGET, &blksize) != 0)
 		ERRMSG_EXIT(EXIT_FAILURE, "%s: (write labels) IOCTL BLKSSZGET "
 			    "failed (%s).\n", prog_name, strerror(errno));
-	
+
+	/*
+         * Don't rely on the cylinders returned by HDIO_GETGEO, they might be
+         * to small. geo is only used to get the number of sectors, which may
+	 * vary depending on the format.
+         */
 	if (ioctl(filedes, HDIO_GETGEO, &geo) != 0)
 		ERRMSG_EXIT(EXIT_FAILURE, "%s: (write labels) IOCTL HDIO_GET"
 			    "GEO failed (%s).\n", prog_name, strerror(errno));
@@ -504,38 +516,48 @@ static void dasdfmt_write_labels(dasdfmt
 			    "failed, only wrote %d bytes.\n", prog_name, rc);
 
 	/* write VTOC */
-	vtoc_init_format4_label(&f4, USABLE_PARTITIONS, geo.cylinders,
-		geo.heads, geo.sectors, blksize, dasd_info.dev_type);
+	vtoc_init_format4_label(&f4, USABLE_PARTITIONS, geo.cylinders, cylinders,
+				heads, geo.sectors, blksize, dasd_info.dev_type);
 
 	vtoc_init_format5_label(&f5);
 	vtoc_init_format7_label(&f7);
 	vtoc_set_freespace(&f4, &f5, &f7, '+', 0, FIRST_USABLE_TRK,
-			   (geo.cylinders * geo.heads - 1),
-			   geo.cylinders, geo.heads);
+			   (cylinders * heads - 1), cylinders, heads);
 
 	label_position = dasd_info.label_block * blksize;
-			
+
 	if (info->verbosity > 0) printf("Writing label...\n");
 
 	rc = lseek(filedes, label_position, SEEK_SET);
 	if (rc != label_position)
 		ERRMSG_EXIT(EXIT_FAILURE, "%s: lseek command to %i failed "
-			    "(%s).\n", prog_name, label_position, 
+			    "(%s).\n", prog_name, label_position,
 			    strerror(errno));
 
+	/*
+	 * Note: cdl volume labels do not contain the 'formatted_blocks' part
+	 * and ldl labels do not contain the key field
+	 */
 	if (info->cdl_format)
-		rc = write(filedes, vlabel, sizeof(volume_label_t));
-	else
-		rc = write(filedes, vlabel->vollbl,(sizeof(volume_label_t)-4));
+		rc = write(filedes, vlabel, (sizeof(*vlabel)
+					     - sizeof(vlabel->formatted_blocks)));
+	else {
+		vlabel->ldl_version = 0xf2; /* EBCDIC '2' */
+		vlabel->formatted_blocks = cylinders * heads * geo.sectors;
+		rc = write(filedes, &vlabel->vollbl, (sizeof(*vlabel)
+						     - sizeof(vlabel->volkey)));
+	}
 
-	if (((rc != sizeof(volume_label_t)) && info->cdl_format) || 
-	    ((rc != (sizeof(volume_label_t)-4)) && (!info->cdl_format)))
+	if (((rc != sizeof(*vlabel) - sizeof(vlabel->formatted_blocks)) &&
+	     info->cdl_format) ||
+	    ((rc != (sizeof(*vlabel)- sizeof(vlabel->volkey))) &&
+	     (!info->cdl_format)))
 		ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing volume label "
 			    "(%d).\n", prog_name, rc);
 
 	if (info->verbosity > 0) printf("Writing VTOC... ");
 
-	label_position = (VTOC_START_CC * geo.heads + VTOC_START_HH) * 
+	label_position = (VTOC_START_CC * heads + VTOC_START_HH) *
 		geo.sectors * blksize;
 
 	rc = lseek(filedes, label_position, SEEK_SET);
@@ -563,7 +585,7 @@ static void dasdfmt_write_labels(dasdfmt
 		ERRMSG_EXIT(EXIT_FAILURE, "%s: Error writing FMT5 label "
 			    "(%d).\n", prog_name, rc);
 
-	if ((geo.cylinders * geo.heads) > BIG_DISK_SIZE) {
+	if ((cylinders * heads) > BIG_DISK_SIZE) {
 		label_position += blksize;
 
 		rc = lseek(filedes, label_position, SEEK_SET);
@@ -588,7 +610,7 @@ static void dasdfmt_write_labels(dasdfmt
 /*
  * formats the disk cylinderwise
  */
-static void dasdfmt_format(dasdfmt_info_t *info, struct hd_geometry *drive_geo,
+static void dasdfmt_format(dasdfmt_info_t *info, unsigned int cylinders, unsigned int heads,
 			   format_data_t *format_params)
 {
 	format_data_t format_step;
@@ -618,7 +640,7 @@ static void dasdfmt_format(dasdfmt_info_
 		p2 =  0;
 
 		format_step.start_unit = k;
-		format_step.stop_unit  = k + drive_geo->heads - 1;
+		format_step.stop_unit  = k + heads - 1;
 
 		if (cyl == 1)
 			format_step.start_unit += 1;
@@ -629,13 +651,13 @@ static void dasdfmt_format(dasdfmt_info_
 				    prog_name, strerror(errno));
 
 		if (info->print_progressbar) {
-			printf("cyl %5d of %5d |", cyl, drive_geo->cylinders);
+			printf("cyl %5d of %5d |", cyl, cylinders);
 			p2 = p1;
-			p1 = cyl*100/drive_geo->cylinders;
+			p1 = cyl*100/cylinders;
 			if (p1 != p2)
 			{
 				/* percent value has changed */
-				tmp = cyl*50/drive_geo->cylinders;
+				tmp = cyl*50/cylinders;
 				for (j=1; j<=tmp; j++)
 					printf("#");
 				for (j=tmp+1; j<=50; j++) 
@@ -652,12 +674,12 @@ static void dasdfmt_format(dasdfmt_info_
 				fflush(stdout);
 			}
 
-		if (k % drive_geo->heads == 0) {
-			k += drive_geo->heads;
+		if (k % heads == 0) {
+			k += heads;
 			cyl++;
 		}
 		else 
-			k += format_params->stop_unit % drive_geo->heads;
+			k += format_params->stop_unit % heads;
 
 		if (k > format_params->stop_unit) 
 			break;
@@ -672,7 +694,8 @@ static void dasdfmt_format(dasdfmt_info_
  *
  */
 static void dasdfmt_prepare_and_format (dasdfmt_info_t *info,
-					struct hd_geometry *drive_geo,
+					unsigned int cylinders,
+					unsigned int heads,
 					format_data_t *p)
 {
 	format_data_t temp = {
@@ -701,7 +724,7 @@ static void dasdfmt_prepare_and_format (
 	/* except track 0 from standard formatting procss */
 	p->start_unit = 1;
 
-	dasdfmt_format(info, drive_geo, p);
+	dasdfmt_format(info, cylinders, heads, p);
 
 	if (info->verbosity > 0) printf("formatting tracks complete...\n");
 
@@ -730,22 +753,48 @@ static void dasdfmt_prepare_and_format (
 static void do_format_dasd(dasdfmt_info_t *info, format_data_t *p, 
 			   volume_label_t *vlabel)
 {
-	struct hd_geometry drive_geo;
 	char               inp_buffer[5];
-
-
+	dasd_information_t  dasd_info;
+	struct dasd_eckd_characteristics *characteristics;
+	unsigned int cylinders, heads;
 
 	if (info->verbosity > 0) printf("Retrieving disk geometry...\n");
 
-	if (ioctl(filedes, HDIO_GETGEO, &drive_geo) != 0)
-		ERRMSG_EXIT(EXIT_FAILURE, "%s: the ioctl call to get geometry "
-			    "returned with the following error message:\n%s\n",
+	if (ioctl(filedes, BIODASDINFO, &dasd_info) != 0)
+		ERRMSG_EXIT(EXIT_FAILURE, "%s: (retrieving disk information) "
+			    "IOCTL BIODASDINFO failed (%s).\n",
 			    prog_name, strerror(errno));
 
+	characteristics =
+		(struct dasd_eckd_characteristics *) &dasd_info.characteristics;
+        if (characteristics->no_cyl == LV_COMPAT_CYL &&
+	    characteristics->long_no_cyl)
+		cylinders = characteristics->long_no_cyl;
+	else
+		cylinders = characteristics->no_cyl;
+	heads = characteristics->trk_per_cyl;
+
 	p->start_unit = 0;
-	p->stop_unit  = (drive_geo.cylinders * drive_geo.heads) - 1;
-			
-        if (!info->writenolabel) {
+	p->stop_unit  = (cylinders * heads) - 1;
+
+        if (info->writenolabel) {
+		if (cylinders > LV_COMPAT_CYL && !info->withoutprompt) {
+			printf("\n--->> ATTENTION! <<---\n");
+			printf("You specified to write no labels to a"
+			       " volume with more then %u cylinders.\n"
+			       "Cylinders above this limit will not be"
+			       " accessable as a linux partition!\n"
+			       "Type \"yes\" to continue, no will leave"
+			       " the disk untouched: ", LV_COMPAT_CYL);
+			fgets(inp_buffer, sizeof(inp_buffer), stdin);
+			if (strcasecmp(inp_buffer,"yes") &&
+			    strcasecmp(inp_buffer,"yes\n")) {
+				printf("Omitting ioctl call (disk will "
+					"NOT be formatted).\n");
+				return;
+			}
+		}
+	} else {
         	if (!info->labelspec && !info->keep_volser) {
 			char buf[7];
 
@@ -759,13 +808,12 @@ static void do_format_dasd(dasdfmt_info_
 			vtoc_volume_label_set_label(vlabel, "VOL1");
 			vtoc_volume_label_set_key(vlabel, "VOL1");
                         vtoc_set_cchhb(&vlabel->vtoc, 0x0000, 0x0001, 0x01);
-                } 
-		else 
+                } else
 			vtoc_volume_label_set_label(vlabel, "LNX1");
        	}
 
 	if ((info->verbosity > 0) || (!info->withoutprompt)) 
-		dasdfmt_print_info(info, vlabel, &drive_geo, p);
+		dasdfmt_print_info(info, vlabel, cylinders, heads, p);
 
 	if (!info->testmode) {
 		if (!info->withoutprompt) {
@@ -786,12 +834,12 @@ static void do_format_dasd(dasdfmt_info_
 			printf("Formatting the device. This may take a "
 			       "while (get yourself a coffee).\n");
 		
-		dasdfmt_prepare_and_format(info, &drive_geo, p);
+		dasdfmt_prepare_and_format(info, cylinders, heads, p);
 
 		if(!info->yast_mode) printf("Finished formatting the device.\n");
 
-		if (!info->writenolabel) 
-			dasdfmt_write_labels(info, vlabel);
+		if (!info->writenolabel)
+			dasdfmt_write_labels(info, vlabel, cylinders, heads);
 
 		if(!info->yast_mode) printf("Rereading the partition table... ");
 		if (reread_partition_table()) {
Index: s390-tools-sles11/dasdfmt/dasdfmt.h
===================================================================
--- s390-tools-sles11.orig/dasdfmt/dasdfmt.h
+++ s390-tools-sles11/dasdfmt/dasdfmt.h
@@ -31,10 +31,10 @@
 
 #define DASD_IOCTL_LETTER 'D'
 
-/* 
+/*
  * struct dasd_information_t
  * represents any data about the device, which is visible to userspace.
- *  including foramt and featueres.
+ *  including format and features.
  */
 typedef struct dasd_information_t {
         unsigned int devno;           /* S/390 devno                        */
@@ -58,15 +58,91 @@ typedef struct dasd_information_t {
         char configuration_data[256]; /* from read_configuration_data       */
 } dasd_information_t;
 
+
+struct dasd_eckd_characteristics {
+	unsigned short cu_type;
+	struct {
+		unsigned char support:2;
+		unsigned char async:1;
+		unsigned char reserved:1;
+		unsigned char cache_info:1;
+		unsigned char model:3;
+	} __attribute__ ((packed)) cu_model;
+	unsigned short dev_type;
+	unsigned char dev_model;
+	struct {
+		unsigned char mult_burst:1;
+		unsigned char RT_in_LR:1;
+		unsigned char reserved1:1;
+		unsigned char RD_IN_LR:1;
+		unsigned char reserved2:4;
+		unsigned char reserved3:8;
+		unsigned char defect_wr:1;
+		unsigned char XRC_supported:1;
+		unsigned char reserved4:1;
+		unsigned char striping:1;
+		unsigned char reserved5:4;
+		unsigned char cfw:1;
+		unsigned char reserved6:2;
+		unsigned char cache:1;
+		unsigned char dual_copy:1;
+		unsigned char dfw:1;
+		unsigned char reset_alleg:1;
+		unsigned char sense_down:1;
+	} __attribute__ ((packed)) facilities;
+	unsigned char dev_class;
+	unsigned char unit_type;
+	unsigned short no_cyl;
+	unsigned short trk_per_cyl;
+	unsigned char sec_per_trk;
+	unsigned char byte_per_track[3];
+	unsigned short home_bytes;
+	unsigned char formula;
+	union {
+		struct {
+			unsigned char f1;
+			unsigned short f2;
+			unsigned short f3;
+		} __attribute__ ((packed)) f_0x01;
+		struct {
+			unsigned char f1;
+			unsigned char f2;
+			unsigned char f3;
+			unsigned char f4;
+			unsigned char f5;
+		} __attribute__ ((packed)) f_0x02;
+	} __attribute__ ((packed)) factors;
+	unsigned short first_alt_trk;
+	unsigned short no_alt_trk;
+	unsigned short first_dia_trk;
+	unsigned short no_dia_trk;
+	unsigned short first_sup_trk;
+	unsigned short no_sup_trk;
+	unsigned char MDR_ID;
+	unsigned char OBR_ID;
+	unsigned char director;
+	unsigned char rd_trk_set;
+	unsigned short max_rec_zero;
+	unsigned char reserved1;
+	unsigned char RWANY_in_LR;
+	unsigned char factor6;
+	unsigned char factor7;
+	unsigned char factor8;
+	unsigned char reserved2[3];
+	unsigned char reserved3[6];
+	unsigned int long_no_cyl;
+} __attribute__ ((packed));
+
+
 /* 
  * struct format_data_t
  * represents all data necessary to format a dasd
  */
 typedef struct format_data_t {
-	int start_unit; /* from track */
-	int stop_unit;  /* to track */
-	int blksize;    /* sectorsize */
-        int intensity;  
+	unsigned int start_unit; /* from track */
+	unsigned int stop_unit;  /* to track */
+	unsigned int blksize;    /* sectorsize */
+        unsigned int intensity;
 } format_data_t;
 
 /*
@@ -95,7 +171,7 @@ typedef struct format_data_t {
 #define BIODASDFMT     _IOW(DASD_IOCTL_LETTER,1,format_data_t) 
 
 /****************************************************************************
- * SECTION: Further IOCTL Definitions  (see fs.h)                           *
+ * SECTION: Further IOCTL Definitions  (see fs.h and hdreq.h )              *
  ****************************************************************************/
 /* re-read partition table */
 #define BLKRRPART  _IO(0x12,95)	
@@ -104,17 +180,6 @@ typedef struct format_data_t {
 /* get read-only status (0 = read_write) */
 #define BLKROGET   _IO(0x12,94)
 
-/****************************************************************************
- * SECTION: Definition from hdreq.h                                         *
- ****************************************************************************/
-
-struct hd_geometry {
-      unsigned char heads;
-      unsigned char sectors;
-      unsigned short cylinders;
-      unsigned long start;
-};
-
 /* get device geometry */
 #define HDIO_GETGEO		0x0301	
 
@@ -172,12 +237,6 @@ static struct option dasdfmt_getopt_long
         {0, 0, 0, 0}
 };
 
-static int            filedes        = 0;
-static int            disk_disabled  = 0;
-static format_data_t  format_params;
-char                 *prog_name;
-volatile sig_atomic_t program_interrupt_in_progress = 0;
-
 typedef struct bootstrap1 {
         u_int32_t key;
         u_int32_t data[6];
